/**
 * Garrison nauts plugin by Lorgan for haxxies 2014
 * Every class gets a unique supermove which can be activated using 'down' (S by default)
*/

global.GNPacketID = packetID;
global.GNspawn = false;

// some constants
globalvar MOBA;
MOBA = id;
sync = false;
price[0] = 5;
price[1] = 2;
price[2] = 2;
price[3] = 2;
price[4] = 2;
price[5] = 8;

// read the ini
ini_open('gg2.ini');
global.GNmode = ini_read_real('server', 'garrison nauts mode', 1);
debug = ini_read_real('server', 'garrison nauts debug', 0);
shop = ini_read_real('server', 'garrison nauts shop', 1);
botLimit = ini_read_real('server', 'garrison nauts botlimit', 20);
syncTime = ini_read_real('server', 'garrison nauts synctime', 14);
ini_write_real('server', 'garrison nauts mode', global.GNmode);
ini_write_real('server', 'garrison nauts debug', debug);
ini_write_real('server', 'garrison nauts shop', shop);
ini_write_real('server', 'garrison nauts botlimit', botLimit);
ini_write_real('server', 'garrison nauts synctime', syncTime);
ini_close();

// Sprites
globalvar GNpowerSelectS, GNpowerSelectBG, GNpowerS, GNmarkerS, GNscoutChargeS, GNspySmokeS, GNsniperBombS, GNheavyShieldS, GNengiBullS, GNsoldierExplosionS, GNdemoPipeS, GNhudS, MOBAbotMoveS, MOBAbotMeleeS, MOBAchainsawKL, MOBAfireKL, MOBAturretKL, MOBAturretBaseS, MOBAturretS, MOBAbotMove2S, MOBAphlogS, GNanchorS, GNturretShieldS, MOBAentityS;
GNpowerSelectS = sprite_add(directory + '/powerSelect.png', 1, 0, 0, 400, 120);
GNpowerSelectBG = sprite_add(directory + '/powerSelectBG.png', 1, 0, 0, 0, 120);
GNpowerS = sprite_add(directory + '/power.png', 12, 0, 0, 0, 0);
GNmarkerS = sprite_add(directory + '/marker.png', 9, 0, 0, 24, -10);
GNscoutChargeS = sprite_add(directory + '/scoutCharge.png', 16, 0, 0, 30, 40);
GNspySmokeS = sprite_add(directory + '/spySmoke.png', 13, 0, 0, 30, 48);
GNsniperBombS = sprite_add(directory + '/sniperBomb.png', 28, 0, 0, 22, 30);
GNheavyShieldS = sprite_add(directory + '/heavyShield.png', 4, 0, 0, 16, 16);
GNengiBullS = sprite_add(directory + '/engiBull.png', 16, 0, 0, 37, 20);
GNsoldierExplosionS = sprite_add(directory + '/soldierExplosion.png', 2, 0, 0, 8, 0);
GNdemoPipeS = sprite_add(directory + '/demoPipe.png', 2, 0, 0, 4, 2);
GNhudS = sprite_add(directory + '/GNhud.png', 2, 0, 0, 0, 0);
MOBAbotMoveS = sprite_add(directory + '/botMove.png', 8, 0, 0, 22, 27);
MOBAbotMeleeS = sprite_add(directory + '/botAttack.png', 28, 0, 0, 22, 27);
MOBAchainsawKL = sprite_add(directory + '/chainsawKL.png', 2, 1, 0, 7, 7);
MOBAturretKL = sprite_add(directory + '/towerKL.png', 2, 1, 0, 13, 4);
MOBAfireKL = sprite_add(directory + '/phlogKL.png', 2, 1, 0, 15, 6);
MOBAturretBaseS = sprite_add(directory + '/turretBase.png', 4, 0, 0, 28, 48);
MOBAturretS = sprite_add(directory + '/turret.png', 4, 0, 0, 8, 6);
MOBAbotMove2S = sprite_add(directory + '/botMove2.png', 8, 1, 0, 22, 27);
MOBAphlogS = sprite_add(directory + '/phlogBeam.png', 4, 0, 0, 0, 20);
GNanchorS = sprite_add(directory + '/anchor.png', 10, 0, 0, 6, 5);
GNturretShieldS = sprite_add(directory + '/shield.gif', 5, 1, 0, 32, 36);
MOBAentityS = sprite_add(directory + '/entities.png', 6, 0, 0, 6, 8);

globalvar genGifRedS, genGifBlueS, genAfterburnRedS, genAfterburnBlueS;
genGifRedS = sprite_add(directory + '/GenGifRed.png',22,1,0,159,153);
genGifBlueS = sprite_add(directory + '/GenGifBlue.png',22,1,0,159,153);
genAfterburnRedS = sprite_add(directory + '/GenAfterburnRed.png',5,1,0,159,153);
genAfterburnBlueS = sprite_add(directory + '/GenAfterburnBlue.png',5,1,0,159,153);

// Collision box 'fixes'
sprite_collision_mask(GNengiBullS, 0, 2, 14, 6, 80, 44, 1, 0);
sprite_collision_mask(MOBAbotMoveS, 0, 2, 14, 14, 30, 41, 1, 0);
sprite_collision_mask(MOBAturretBaseS, 0, 2, 20, 16, 44, 71, 1, 0);

// Sounds
globalvar GNslideSnd, GNshieldSnd, GNexplosionSnd;
GNslideSnd = sound_add(directory + '/slide.wav', 0, 1);
GNshieldSnd = sound_add(directory + '/heavyShield.wav', 0, 1);
GNexplosionSnd = sound_add(directory + '/soldierBomb.wav', 0, 1);

// Extra game mode
execute_file(directory + '/moba.gml');
execute_file(directory + '/powerMenu.gml');

// Extra objects
execute_file(directory + '/spyBomb.gml');
execute_file(directory + '/sniperBomb.gml');
execute_file(directory + '/engiBull.gml');
execute_file(directory + '/pyroBlaze.gml');
execute_file(directory + '/soldierBomb.gml');
execute_file(directory + '/demoPipe.gml');

// Vanilla is broken, remove this script when the issues are resolved.
execute_file(directory + '/vanillafixes.gml');

// Add a button configuration to the menu
object_event_add(AdvControlsController, ev_create, 0, '
    menu_addedit_key("Open powerup menu:", "global.GNpowerMenu");
    menu_addedit_key("Activate super (garrisonnauts):", "global.GNsuperButton");
');
object_event_add(AdvControlsController, ev_destroy, 0, '
    ini_open("controls.gg2");
    ini_write_real("Controls", "GNsuper", global.GNsuperButton);
    ini_write_real("Controls", "GNpowerMenu", global.GNpowerMenu);
    ini_close();
');

ini_open("controls.gg2");
global.GNsuperButton = ini_read_real("Controls", "GNsuper", ord("S"));
global.GNpowerMenu = ini_read_real("Controls", "GNpowerMenu", ord("B"));
ini_close();

// Use the damage API
global.dealDamageFunction += '
    if (argument0 != noone && instance_exists(argument0)) {
        argument1.lastDamageDealer = argument0;  // Fix to give mobabots (generators) a last damage dealer

        if (argument0.object_index == Player) {
            // extra damage upgrades
            if (argument0.GNupgrades[4]) {
                argument1.hp -= argument2*0.25;    
            }
        }
    }
    
    // resistance for heavy
    if (object_is_ancestor(argument1.object_index, Character)) {
        if (argument1.player.class == CLASS_HEAVY && argument1.GNsuper) {
            argument1.hp += argument2*0.5;
            argument1.GNanimationIndex = 1;
        }
    }
    
    // Bots get a shield
    if (argument1.object_index == MOBAbot) {
        if (argument1.shield) {
            argument1.hp += argument2*0.25;
        }
        if (argument0 != noone && instance_exists(argument0)) {
            if (argument0.object_index == MOBAturret) {
                if (!argument1.super) argument1.hp += argument2*0.33;     // normal bots have resistance against turrets
                with(MOBAbot) {
                    if (team == argument1.team && point_distance(argument1.x, argument1.y, x, y) <= 64) {
                        shield = 1;
                        alarm[8] = 60 / global.delta_factor;
                    }
                }
            }
        }
    } else if (argument1.object_index == MOBAturret) {
        if (argument1.shield) {
            argument1.hp += argument2/2;
            argument1.shieldIndex = 1;
        }
    }
    
    // Turrets will target attackers
    if (argument1.object_index == MOBAturret && argument0 != noone) {
        if (argument0.object_index == Player) {
             argument1.trueTarget = argument0.object;
             argument1.alarm[1] = 20/global.delta_factor;
        }
    }
';

// Kill log script
global.killLogScript = '
    switch(argument0) {
        case 0:
            ds_map_replace(argument1.entry, "name1", "a droid")
            ds_map_replace(argument1.entry, "team1", !argument1.team);
            ds_map_replace(argument1.entry, "weapon", MOBAchainsawKL);
        break;
        case 1:
            ds_map_replace(argument1.entry, "name1", "a turret")
            ds_map_replace(argument1.entry, "team1", !argument1.team);
            ds_map_replace(argument1.entry, "weapon", MOBAturretKL);
        break;
        case 2:
            ds_map_replace(argument1.entry, "name1", "a superdroid")
            ds_map_replace(argument1.entry, "team1", !argument1.team);
            ds_map_replace(argument1.entry, "weapon", MOBAfireKL);
        break;
    }
';

/****************************************
 * Modifications to the Player object
****************************************/
object_event_add(Player, ev_create, 0, '
    oldCaps = stats[CAPS];
    for(i=0; i<6; i+=1) GNupgrades[i] = false;
    entry = -1;
    spentPoints = 0; 
    
    if (instance_exists(MOBAcontroller)) {    
        // "balance" money/points
        var totalPoints;
        totalPoints = 0;
        with(Player) {
            totalPoints += stats[POINTS];
        }
        stats[POINTS] = ceil(totalPoints / max(1, instance_number(Player)-1) * 0.2);
    }
');
with(Player) {
    oldCaps = stats[CAPS];
    for(i=0; i<6; i+=1) GNupgrades[i] = false;
    spentPoints = 0;
}
object_event_add(Player, ev_step, ev_step_normal, '
    if (stats[CAPS] > oldCaps) {
        if (object != -1 && instance_exists(object)) {
            object.GNsuperUnlocked = true;
        }
    }
    oldCaps = stats[CAPS];
');
object_event_add(Player, ev_step, ev_step_begin, '
    if (variable_local_exists("GNinit")) exit;
    GNinit = 1;
    
    if(global.isHost) {
        var buffer;
        buffer = buffer_create();
        for(i=0; i<ds_list_size(global.players); i+=1) {
            var _player;
            _player = ds_list_find_value(global.players, i);
            if (_player.object != -1 && instance_exists(_player.object)) {
                if (_player.object.GNsuperUnlocked || global.GNmode >= 2) {
                    write_ubyte(buffer, 0);
                    write_ubyte(buffer, i);
                }
            }
        }
        if (buffer_size(buffer) > 0) {
            PluginPacketSendTo(global.GNPacketID, buffer, id);
        }
        if (global.GNmode >= 2 && !global.isHost) {
            buffer_clear(buffer);
            write_ubyte(buffer, 2);
            PluginPacketSendTo(global.GNPacketID, buffer, id);
        }
        buffer_destroy(buffer);
    }
');
object_event_add(Player, ev_destroy, 0, '
    with(GNspyBomb) {
        if (ownerPlayer == other.id) instance_destroy();
    }
    with(GNdemoPipe) {
        if (ownerPlayer == other.id) instance_destroy();
    }
    with(GNengiBull) {
        if (ownerPlayer == other.id) instance_destroy();
    }
    with(GNsniperBomb) {
        if (ownerPlayer == other.id) instance_destroy();
    }
    with(GNsoldierBomb) {
        if (ownerPlayer == other.id) instance_destroy();
    }
');   
object_event_add(Player, ev_other, ev_user12, '
    if(global.updateType == FULL_UPDATE){
        var temp;
        temp = 0;
        if (GNupgrades[0]) temp |= $01;
        if (GNupgrades[1]) temp |= $02;
        if (GNupgrades[2]) temp |= $04;
        if (GNupgrades[3]) temp |= $08;
        if (GNupgrades[4]) temp |= $10;
        if (GNupgrades[5]) temp |= $20;
        write_ubyte(global.serializeBuffer, temp);  
    } 
');            
object_event_add(Player, ev_other, ev_user13, '
    var temp;
    if(global.updateType == FULL_UPDATE) {
        receiveCompleteMessage(global.serverSocket,1,global.deserializeBuffer);
        temp = read_ubyte(global.deserializeBuffer);
        GNupgrades[0] = (temp & $01 != 0);
        GNupgrades[1] = (temp & $02 != 0);
        GNupgrades[2] = (temp & $04 != 0);
        GNupgrades[3] = (temp & $08 != 0);
        GNupgrades[4] = (temp & $10 != 0);
        GNupgrades[5] = (temp & $20 != 0);
        if (object != -1) {
            if (GNupgrades[0]) object.GNsuperUnlocked = 1;
            if (GNupgrades[1]) object.maxHp *= 1.25;
            if (GNupgrades[3])  {
                object.runPower *= 1.25;
                object.runBkp = object.runBkp;
            }
        }
    }
'); 

/****************************************
 * Modifications to the Character object
****************************************/
object_event_add(Character, ev_create, 0 ,'
    GNsuperUnlocked = 0;
    if (global.GNspawn || ((global.GNmode >= 2 || (global.GNmode == 0 && instance_exists(ArenaHUD)) || instance_exists(GeneratorHUD)) && global.isHost && !instance_exists(MOBAcontroller))) GNsuperUnlocked = 1;
    GNsuperStart = 0;
    GNsuper = 0;
    GNsuperEnd = 0;
    GNsuperCooldown = 0;
    GNsuperReload = 0;
    GNsuperMaxReload = 10;
    
    GNmoveDir = -1;
    GNmoveX = 0;
    GNmoveY = 0;
    GNtagQueue = ds_list_create();
    GNlastHP = 0;
    GNanimationIndex = 0;
    GNstun = 0;
    GNbullHit = 0;
    
    GNmarkerIndex = 0;
    
    for(i=1; i<6; i+=1) global.paramPlayer.GNupgrades[i] = false;   // reset
    if (global.paramPlayer.GNupgrades[0]) GNsuperUnlocked = 1;
    /*if (global.paramPlayer.GNupgrades[1]) maxHp *= 1.25;
    if (global.paramPlayer.GNupgrades[3]) runPower *= 1.25;*/
    runBkp = runPower; 
');
object_event_add(Character, ev_step, ev_step_begin, ' 
    // health regen
    if (player.GNupgrades[2]) hp = min(maxHp, hp+0.03*global.delta_factor);
  
    // Stun on characters
    if (GNstun > 0) {
        GNstun -= 1 * global.delta_factor;
        hspeed /= 2.5;
        vspeed /= 2.5;
    } else {
        GNstun = 0;
    }
    
    // Bull movement cooldown
    if (GNbullHit > 0) GNbullHit -= 1 * global.delta_factor;
    
    if (!GNsuperUnlocked) {
        if (global.isHost && global.GNmode == 1) {
            if (intel) {
                GNsuperUnlocked = true;
                    var buffer;
                    buffer = buffer_create();
                    write_ubyte(buffer, 0);
                    write_ubyte(buffer, ds_list_find_index(global.players, player));
                    PluginPacketSend(global.GNPacketID, buffer);
                    buffer_destroy(buffer);
            }
            if (cappingPoint != noone) {
                if (cappingPoint.capping != 0) {
                    GNsuperUnlocked = true;
                    var buffer;
                    buffer = buffer_create();
                    write_ubyte(buffer, 0);
                    write_ubyte(buffer, ds_list_find_index(global.players, player));
                    PluginPacketSend(global.GNPacketID, buffer);
                    buffer_destroy(buffer);
                }
            }
        }
        exit;
    }
     
    // Initialize the effect
    if (GNsuperStart) {
        GNsuperStart = 0;
        GNsuperCooldown = 10;
        GNsuperReload = 10;
        
        switch(player.class) {
            case CLASS_SCOUT:
                runPower = 0;
                GNmoveDir = aimDirection;
                GNsuperCooldown = 30;
                GNsuperReload = 5*30;
                
                // Cheat a bit to display an animation
                taunting = true;
                _oldTauntSprite = tauntsprite;
                tauntsprite = GNscoutChargeS;
                tauntlength = sprite_get_number(tauntsprite)/2;
                tauntindex=tauntlength * player.team;
                tauntend=tauntlength * (1 + player.team) - 1;
                tauntspeed = 4;
            break;
            case CLASS_SPY:
                var bomb;
                bomb = instance_create(x,y, GNspyBomb);
                bomb.ownerPlayer = player;
                bomb.direction = aimDirection;
                playsound(x,y,MinegunSnd);
                GNsuperCooldown = 0;        
                GNsuperReload = 8*30;       
            break;
            case CLASS_SNIPER:
                var bomb;
                bomb = instance_create(x,y, GNsniperBomb);
                bomb.ownerPlayer = player;
                bomb.direction = aimDirection;
                playsound(x,y,MinegunSnd);
                GNsuperCooldown = 0;
                GNsuperReload = 8*30;    
            break;
            case CLASS_HEAVY:
                GNlastHP = hp;
                playsound(x,y, GNshieldSnd);
                GNsuperCooldown = 120;
                GNsuperReload = 9*30;
            break;
            case CLASS_ENGINEER:
                var bull;
                bull = instance_create(x,y, GNengiBull);
                bull.ownerPlayer = player;
                bull.image_xscale = image_xscale;
                bull.direction = -image_xscale*90+90;
                playsound(x,y,SentryBuildSnd);
                GNsuperCooldown = 0; 
                GNsuperReload = 5*30;
            break;
            case CLASS_PYRO:
                runPower *= 1.25;
                GNmoveX = 0;
                GNsuperCooldown = 120;
                playsound(x, y , BladeSnd);
                GNsuperReload = 9*30;
            break;
            case CLASS_QUOTE:
                runPower = 0;
                GNsuperCooldown = 120;
                playsound(x, y, SentryAlert);
                GNsuperReload = 5*30;
            break;
            case CLASS_SOLDIER:
                var bomb;
                bomb = instance_create(x, y, GNsoldierBomb);
                bomb.ownerPlayer = player;
                bomb.direction = aimDirection;
                playsound(x,y,MinegunSnd);
                GNsuperCooldown = 0;  
                GNsuperReload = 5*30;
            break;
            case CLASS_MEDIC:
                playsound(x, y, UberEndSnd);
                GNsuperCooldown = 120;
                GNsuperReload = 30*30;
            break;
            case CLASS_DEMOMAN:
                playsound(x, y, MinegunSnd);
                var bomb;
                bomb = instance_create(x,y, GNdemoPipe);
                bomb.ownerPlayer = player;
                bomb.direction = aimDirection-5;
                bomb.speed = 6;
                bomb.owner=id;
                bomb.team=player.team;
                bomb.hspeed += hspeed;
                
                bomb = instance_create(x,y, GNdemoPipe);
                bomb.ownerPlayer = player;
                bomb.direction = aimDirection+5;
                bomb.speed = 8;
                bomb.owner=id;
                bomb.team=player.team;
                bomb.hspeed += hspeed;
                GNsuperCooldown = 0;  
                GNsuperReload = 4*30; 
            break;
        }
        
        GNsuperMaxReload = GNsuperReload;
    }
    
    // While the effect is in progress
    if (GNsuper) {
        GNsuperCooldown -= 1*global.delta_factor;
        if (GNsuperCooldown <= 0) {
            GNsuper = 0;
            GNsuperEnd = 1;
        }

        switch(player.class) {
            case CLASS_SCOUT:
                if (GNsuperCooldown == 20) {
                    playsound(x,y,GNslideSnd);
                    tauntindex += tauntspeed * 0.3;
                    GNmoveX = x;
                    GNmoveY = y;
                } else if (GNsuperCooldown < 20) {
                    tauntindex -= tauntspeed*0.1 * global.delta_factor; // Even more cheating :3
                    if (GNbullHit <= 0) {
                        hspeed = 17*((((GNmoveDir+270) mod 360)>180)*2-1);
                        vspeed = lengthdir_y(15, GNmoveDir);
                        moveStatus = 0;
                    }
                }
            break;    
            case CLASS_PYRO:
                spinjumping = true;
                GNmoveX += 1 * global.delta_factor;
                if (GNmoveX >= 3) {
                    GNmoveX = 0;
                    shot = instance_create(x, y, GNpyroBlaze);
                    shot.speed = 0;
                    shot.owner = id;
                    shot.ownerPlayer = player;
                    shot.team = player.team;
                    shot.weapon = WEAPON_FLAMETHROWER;
                }
            break;   
            case CLASS_QUOTE:
                currentWeapon.readyToShoot = false;
                if (GNbullHit <= 0) {
                    hspeed = lengthdir_x(8 * min(timeUnscathed/100+0.6, 1-intel/2), aimDirection);
                    vspeed = lengthdir_y(8 * min(timeUnscathed/100+0.6, 1-intel/2), aimDirection);
                }
                
                if (hp <= 5) {
                    GNsuperCooldown = 0;
                    playsound(x, y, ExplosionSnd);
                } else {
                    hp -= 0.3 * global.delta_factor;
                    with(Character) {
                        if (player.team != other.player.team && ubered == 0) {
                            if (point_distance(x, y, other.x, other.y) < 70) {
                                damageCharacter(other.player, id, 2*global.delta_factor);
                                if (lastDamageDealer != other.player and lastDamageDealer != player)
                                {
                                    secondToLastDamageDealer = lastDamageDealer;
                                    alarm[4] = alarm[3]
                                }
                                alarm[3] = ASSIST_TIME;
                                lastDamageDealer = other.player;
                                lastDamageSource = WEAPON_REFLECTED_STICKY;
                                dealFlicker(id);
                                other.hp += 2 * global.delta_factor;
                            }
                        }
                    }
                    with(Sentry) {
                        if (team != other.player.team) {
                            if (point_distance(x, y, other.x, other.y) < 7) {
                                damageSentry(other.player, id, 2*global.delta_factor);
                                lastDamageDealer = other.player;
                                lastDamageSource = WEAPON_REFLECTED_STICKY;
                            }
                        }
                    }
                }
            break;   
            case CLASS_MEDIC:
                with(Character) {
                    if (player.team != other.player.team && ubered == 0 && point_distance(x, y, other.x, other.y) < 300 && !place_meeting(x,y,SpawnRoom) && collision_line(x, y, other.x, other.y, Obstacle, true, true) <= -1 && !cloak) {        
                        damageCharacter(other.player, id, 0.5*global.delta_factor);
                        if (lastDamageDealer != other.player and lastDamageDealer != player)
                        {
                            secondToLastDamageDealer = lastDamageDealer;
                            alarm[4] = alarm[3]
                        }
                        alarm[3] = ASSIST_TIME;
                        lastDamageDealer = other.player;
                        lastDamageSource = 255;
                    }
                }
            break;  
        }
    } else if (GNsuperReload > 0) {
        GNsuperReload -= 1*global.delta_factor;
    }
    
    // Terminate the effect
    if (GNsuperEnd) {
        GNsuperEnd = 0;
        switch(player.class) {
            case CLASS_SCOUT:
                runPower = runBkp;
                doublejumpUsed = 1;
                ds_list_clear(GNtagQueue);
                tauntsprite = _oldTauntSprite;
                tauntlength = sprite_get_number(tauntsprite)/2;
                tauntspeed = 3;
                taunting = false;
            break;
            case CLASS_PYRO:
                runPower = runBkp;
                spinjumping = false;
            break;
            case CLASS_QUOTE:
                currentWeapon.readyToShoot = true;
                runPower = runBkp;
            break;
        }
    }
'); 

object_event_add(Character, ev_destroy, 0, '
    ds_list_destroy(GNtagQueue);
    player.humiliated = false;
	
    // If you are using this code, smash your keyboard to get a random number for your death causes to prevent incompatibility
    if (lastDamageSource >= 4150 && lastDamageSource <= 4152) {
        with(KillLog) {
            // not 100% foolproof (players may have the same name) but this will do.
            other.player.entry = ds_list_find_value(kills, ds_list_size(kills)-1);
            if (other.player.entry > 0) {
                if (ds_map_find_value(other.player.entry, "name2") == other.player.name) {
                    if (global.isHost) {     
                        var buffer;
                        buffer = buffer_create();
                        write_ubyte(buffer, 7);
                        write_ubyte(buffer, ds_list_find_index(global.players, other.player));
                        write_ubyte(buffer, other.lastDamageSource-4150);
                        PluginPacketSend(global.GNPacketID, buffer);
                        buffer_destroy(buffer);
                        
                        execute_string(global.killLogScript, other.lastDamageSource-4150, other.player);
                    }
                }
            }
        }
    }
');

// Draw effects
object_event_add(Character, ev_draw, 0, '
    xoffset = view_xview[0];
    yoffset = view_yview[0];
    xsize = view_wview[0];
    ysize = view_hview[0];

    if (distance_to_point(xoffset+xsize/2,yoffset+ysize/2) > 800) exit;
    if (invisible) exit;

    if (GNsuperUnlocked) {
        var color;
        if (player.team == TEAM_RED) color = c_orange;
        else color = c_aqua;
        
        if (player.class == CLASS_QUOTE) {
            draw_sprite_ext(GNmarkerS, floor(GNmarkerIndex), x, y-12, 1, 1, 0, color, image_alpha-0.3);
        } else {
            draw_sprite_ext(GNmarkerS, floor(GNmarkerIndex), x, y, 1, 1, 0, color, image_alpha-0.3);
        }
        
        GNmarkerIndex += 0.25*global.delta_factor;
        if (GNmarkerIndex >= 9) GNmarkerIndex -= 9;
    }
    
    if (GNsuper && !GNsuperStart) {
        switch(player.class) {
            case CLASS_SCOUT:
                if (GNsuperCooldown < 20) {
                    var i, GNx, GNy;
                    GNx = x;
                    GNy = y;
                    for (i=0; i<6; i+=1) {
                        draw_sprite_ext(GNscoutChargeS, 7 + 8*player.team, GNx-hspeed*1.2, GNy-vspeed*1.2, image_xscale, 1, 0, c_white, 0.2);
                        GNx -= hspeed/1.7;
                        GNy -= vspeed/1.7;
                    } 
                }           
            break;
            case CLASS_HEAVY: 
                draw_sprite_ext(GNheavyShieldS, ceil(GNanimationIndex) + player.team*2, x, y, 1.5, 1.5, 0, c_white, 0.6);
                GNanimationIndex = max(0, GNanimationIndex-0.3*global.delta_factor);
            break;
            case CLASS_QUOTE:
                draw_sprite_ext(GNheavyShieldS, floor(GNanimationIndex) + player.team*2, x, y, 2.1, 2.1, 0, c_white, 0.6);
                GNanimationIndex += 0.3*global.delta_factor;
                if (GNanimationIndex >= 2) {
                    GNanimationIndex -= 2;
                }
            break;
            case CLASS_MEDIC:
                var color, xdrawpos, ydrawpos;
                if(player.team == TEAM_RED) color = c_red;
                else color = c_blue;
                xdrawpos = round(currentWeapon.x+currentWeapon.xoffset*image_xscale);
                ydrawpos = round(currentWeapon.y+currentWeapon.yoffset);
                draw_set_alpha(0.3);
                
                with(Character) {
                    if (player.team != other.player.team && ubered == 0 && point_distance(x, y, other.x, other.y) < 300 && !place_meeting(x,y,SpawnRoom) && collision_line(x, y, other.x, other.y, Obstacle, true, true) <= -1 && !cloak) {        
                        draw_line_width_color(xdrawpos+lengthdir_x(20,other.aimDirection),ydrawpos+lengthdir_y(20,other.aimDirection), x, y, 5, color, color);
                    }
                }
            break;
        }
    }
');

object_event_add(Character, ev_collision, Character, '
    if (player.class == CLASS_SCOUT && GNsuper && GNsuperCooldown < 20) {
        if (other.player.team != player.team && ds_list_find_index(GNtagQueue, other.id) == -1 && other.ubered == 0) {
            ds_list_add(GNtagQueue, other.id);
            damageCharacter(player, other.id, 50);
            if (other.lastDamageDealer != player and other.lastDamageDealer != other.player)
            {
                other.secondToLastDamageDealer = other.lastDamageDealer;
                other.alarm[4] = other.alarm[3]
            }
            other.alarm[3] = ASSIST_TIME;
            other.lastDamageDealer = player;
            other.lastDamageSource = WEAPON_REFLECTED_ROCKET;
            
            var blood;
            repeat(3) {
                blood = instance_create(x,y,Blood);
                blood.direction = random(360);
            }
            dealFlicker(other.id);
            with(other)
            {
                motion_add(other.direction, other.speed*0.3);
            }
        }
    } else if (player.class == CLASS_HEAVY && GNsuper) {
        if (other.player.team != player.team) {
            with(other) motion_add(sign(x-other.x), 4);
        }
    }
');

object_event_add(Character, ev_collision, Sentry, '
    if (player.class == CLASS_SCOUT && GNsuper && GNsuperCooldown < 20) {
        if (other.team != player.team && ds_list_find_index(GNtagQueue, other.id) == -1) {
            ds_list_add(GNtagQueue, other.id);
            damageSentry(player, other.id, 50);
        }
    }
');

object_event_add(Character, ev_collision, Generator, '
    if (player.class == CLASS_SCOUT && GNsuper && GNsuperCooldown < 20) {
        if (other.team != player.team && ds_list_find_index(GNtagQueue, other.id) == -1) {
            ds_list_add(GNtagQueue, other.id);
            damageGenerator(player, other.id, 50);
        }
    } else if (player.class == CLASS_HEAVY && GNsuper && other.object_index == MOBAbot) {
        if (other.team != player.team) {
            with(other) {
                state = 0;
                alarm[9] = 10 / global.delta_factor;
                motion_add(sign(x-other.x), 4);
            }
        }
    }
');
/****************************************
 * Sentry kill log icons
****************************************/
object_event_add(Sentry, ev_destroy, 0, '
    if (lastDamageSource >= 4150 && lastDamageSource <= 4152) {
        with(KillLog) {
            var exists;
            exists = 0;
            other.ownerPlayer.entry = ds_list_find_value(kills, ds_list_size(kills)-1);
            if (other.ownerPlayer.entry > 0) {
                if (ds_map_find_value(other.ownerPlayer.entry, "name2") == "Autogun (" + other.ownerPlayer.name + ")") {
                    exists = 1;
                }
            }
            if (!exists) {
                // Make one
                recordDestructionInLog(other.ownerPlayer, other.ownerPlayer, noone, -1);
                other.ownerPlayer.entry = ds_list_find_value(kills, ds_list_size(kills)-1);
            }
            if (global.isHost) {
                execute_string(global.killLogScript, other.lastDamageSource-4150, other.ownerPlayer);
                
                var buffer;
                buffer = buffer_create();
                write_ubyte(buffer, 7);
                write_ubyte(buffer, ds_list_find_index(global.players, other.ownerPlayer));
                write_ubyte(buffer, other.lastDamageSource-4150);
                PluginPacketSend(global.GNPacketID, buffer);
                buffer_destroy(buffer);
            }
        }
    }
');

/****************************************
 * Extra syncing & button presses
****************************************/
object_event_add(PlayerControl, ev_step, ev_step_begin, '
    if (!instance_exists(MenuController) && global.myself.team != -1 && global.myself.object != -1 && global.myself.humiliated == 0) {
        if (keyboard_check_pressed(global.GNpowerMenu) && collision_circle(global.myself.object.x,global.myself.object.y,5,SpawnRoom, 0, 1) > 0 && !global.mapchanging && instance_exists(MOBAcontroller)) {
            TeamSelectController.done = true;
            ClassSelectController.done = true;
            if !instance_exists(ClassSelectController) {
                instance_create(0,0,GNpowerSelectController);
                
                // sync points
                if (!global.isHost) {
                    var buffer;
                    buffer = buffer_create();
                    write_ubyte(buffer, 6);
                    PluginPacketSend(global.GNPacketID, buffer);
                    buffer_destroy(buffer);
                }
            }
        } else if (keyboard_check_pressed(global.GNsuperButton)) {
            if (!global.myself.object.cloak) {
                var buffer;
                buffer = buffer_create();
                write_ubyte(buffer, 1);
                
                if (global.isHost) {
                    PluginPacketSendTo(global.GNPacketID, buffer, global.myself);
                } else {
                    PluginPacketSend(global.GNPacketID, buffer);
                }
                buffer_destroy(buffer);
            }
        }
    }

    if (global.isHost) {
        while(PluginPacketGetBuffer(global.GNPacketID) != -1) {
            receiveBuffer = PluginPacketGetBuffer(global.GNPacketID);
            player = PluginPacketGetPlayer(global.GNPacketID);
            if (player == -1 || !instance_exists(player)) break;
            switch(read_ubyte(receiveBuffer)) {
                case 1:
                    if (player.object != -1 && instance_exists(player.object) && !player.humiliated) {
                        if (player.object.GNsuperUnlocked && player.object.GNsuperCooldown <= 0 && player.object.GNsuperReload <= 0 && !player.object.cloak) {
                            player.object.GNsuperStart = 1;
                            player.object.GNsuper = 1;
                        
                            var buffer;
                            buffer = buffer_create();
                            write_ubyte(buffer, 1);
                            write_ubyte(buffer, ds_list_find_index(global.players, player));
                            PluginPacketSend(global.GNPacketID, buffer);
                        }
                    }
                break;
                case 5:
                    if (player.object != -1 && instance_exists(player.object) && !player.humiliated) {                       
                        if (!MOBA.shop) break;
                        upgrade = read_ubyte(receiveBuffer);
                        if (upgrade < 6) {
                            if (player.stats[POINTS] - player.spentPoints >= MOBA.price[upgrade] && !player.GNupgrades[upgrade]) {
                                player.spentPoints += MOBA.price[upgrade];
                                player.GNupgrades[upgrade] = 1;
                                if (player == global.myself) playsound(view_xview[0]+view_wview[0]/2, view_yview[0]+view_hview[0]/2, PickupSnd);
                            } else break;
                        } else break;
                        
                        // Tell clients
                        var buffer;
                        buffer = buffer_create();
                        write_ubyte(buffer, 5);
                        write_ubyte(buffer, ds_list_find_index(global.players, player));
                        write_ubyte(buffer, upgrade);
                        PluginPacketSend(global.GNPacketID, buffer);
                        buffer_destroy(buffer);
                        
                        // Apply effects
                        switch(upgrade) {
                            case 0: player.object.GNsuperUnlocked = 1; break;
                            case 1: player.object.maxHp *= 1.25; break;
                            case 3: 
                                player.object.runPower *= 1.25;
                                player.object.runBkp = player.object.runPower;
                            break;
                            case 5:
                                // Spawn superbot
                                if (player.team == TEAM_RED) {
                                    with(MOBAredSpawn) {
                                        var bot;
                                        bot = instance_create(x, y, MOBAbot);
                                        bot.dir = 1;
                                        bot.direction = 0;
                                        bot.team = TEAM_RED;
                                        bot.super = 1;
                                        bot.maxHp = 200;
                                        bot.hp = 200;
                                    }
                                } else {
                                    with(MOBAblueSpawn) {
                                        var bot;
                                        bot = instance_create(x, y, MOBAbot);
                                        bot.dir = -1;
                                        bot.direction = 180;
                                        bot.team = TEAM_BLUE;
                                        bot.super = 1;
                                        bot.hp = 200;
                                        bot.maxHp = 200;
                                    }
                                }
                            break;
                        }
                    }
                break;
                case 6:
                    var buffer;
                    buffer = buffer_create();
                    write_ubyte(buffer, 6);
                    for(i=0; i<ds_list_size(global.players); i+=1) {
                        write_ubyte(buffer, ds_list_find_value(global.players, i).stats[POINTS]);
                    }
                    if (MOBA.shop) write_ubyte(buffer, player.spentPoints);
                    else write_ubyte(buffer, 255);
                    PluginPacketSendTo(global.GNPacketID, buffer, player); 
                    buffer_destroy(buffer);
                break;
                
            }
            PluginPacketPop(global.GNPacketID);
        }
    } else {
        while(PluginPacketGetBuffer(global.GNPacketID) != -1) {
            receiveBuffer = PluginPacketGetBuffer(global.GNPacketID);
            switch(read_ubyte(receiveBuffer)) {
                case 0:
                    // a player that gained super powers
                    player = ds_list_find_value(global.players, read_ubyte(receiveBuffer));
                    if (player.object != -1 && instance_exists(player.object)) {
                        player.object.GNsuperUnlocked = 1;
                    }
                break;
                case 1:
                    // a player activates his super move
                    player = ds_list_find_value(global.players, read_ubyte(receiveBuffer));
                    if (player.object != -1 && instance_exists(player.object)) {
                        player.object.GNsuperUnlocked = 1;
                        player.object.GNsuperStart = 1;
                        player.object.GNsuper = 1;
                    }
                break;
                case 2:
                    // The server is on garrison nauts mode 2 so spawn with super
                    global.GNspawn = true;
                break;
                case 3:
                    // Sync bots
                    var left, i;
                    left = read_ubyte(receiveBuffer) - instance_number(MOBAbot);
                    if (left > 0) {
                        for(i=0; i<left; i+=1) {
                            instance_create(0,0, MOBAbot);
                        }
                    } else if (left < 0) {
                        i=0;
                        with(MOBAbot) {
                            instance_destroy();
                            i-=1;
                            if (i == left) break;
                        }
                    }
                    
                    MOBA.sync = true;
                    global.MOBAbuffer = receiveBuffer;
                    with(MOBAbot) event_user(13);
                    with(MOBAturret) event_user(13);
                    MOBA.sync = false;
                break;
                case 4:
                    // Spawn bots
                    with(MOBAcontroller) event_user(0);
                break;
                case 5:
                    // Upgrades
                    player = ds_list_find_value(global.players, read_ubyte(receiveBuffer));
                    if (player.object != -1 && instance_exists(player.object)) {
                        upgrade = read_ubyte(receiveBuffer);
                        player.GNupgrades[upgrade] = 1;
                        player.spentPoints += MOBA.price[upgrade];
                        if (player == global.myself) playsound(view_xview[0]+view_wview[0]/2, view_yview[0]+view_hview[0]/2, PickupSnd);
                        
                        // Apply effects
                        switch(upgrade) {
                            case 0: player.object.GNsuperUnlocked = 1; break;
                            case 1: player.object.maxHp *= 1.25; break;
                            case 3: 
                                player.object.runPower *= 1.25;
                                player.object.runBkp = player.object.runPower;
                            break;
                            case 5:
                                // Spawn superbot
                                if (player.team == TEAM_RED) {
                                    with(MOBAredSpawn) {
                                        var bot;
                                        bot = instance_create(x, y, MOBAbot);
                                        bot.dir = 1;
                                        bot.direction = 0;
                                        bot.team = TEAM_RED;
                                        bot.super = 1;
                                        bot.maxHp = 200;
                                        bot.hp = 200;
                                    }
                                } else {
                                    with(MOBAblueSpawn) {
                                        var bot;
                                        bot = instance_create(x, y, MOBAbot);
                                        bot.dir = -1;
                                        bot.direction = 180;
                                        bot.team = TEAM_BLUE;
                                        bot.super = 1;
                                        bot.hp = 200;
                                        bot.maxHp = 200;
                                    }
                                }
                            break;
                        }
                    }
                break;
                case 6:
                    // Sync points (for upgrades)
                    for(i=0; i<ds_list_size(global.players); i+=1) {
                        (ds_list_find_value(global.players, i)).stats[POINTS] = read_ubyte(receiveBuffer);
                    }
                    global.myself.spentPoints = read_ubyte(receiveBuffer); 
                break;
                case 7:
                    player = ds_list_find_value(global.players, read_ubyte(receiveBuffer));
                    if (player.entry != -1) {
                        execute_string(global.killLogScript, read_ubyte(receiveBuffer), player);
                        player.entry = -1;
                    }
                break;
            }
            PluginPacketPop(global.GNPacketID);
        }
    }
');

/****************************************
 * Draw the superhud
****************************************/
object_event_add(HealthHud, ev_draw, 0, '
    xsize = view_wview[0];
    ysize = view_hview[0];
    
    if(global.myself.object == -1) {
        instance_destroy();
        exit; 
    }
    if (global.myself.team == TEAM_RED) draw_set_color(make_color_rgb(165, 70, 64));
    else draw_set_color(make_color_rgb(73, 93, 104));
    draw_rectangle(view_xview[0]+91, view_yview[0]+ysize-51, view_xview[0]+121, view_yview[0]+ysize-16, false);
    
    if (global.myself.object.GNsuperReload > 0) {
        draw_set_color(c_black);
        draw_set_alpha(0.5);
        draw_rectangle(view_xview[0]+91, view_yview[0]+ysize-51+35 * (1-(global.myself.object.GNsuperReload/global.myself.object.GNsuperMaxReload)), view_xview[0]+121, view_yview[0]+ysize-16, false);
    }
    draw_sprite_ext(GNhudS, global.myself.object.GNsuperUnlocked, view_xview[0]+87, view_yview[0]+ysize-55, 2, 2, 0, c_white, 1);
');

/****************************************
 * Make airblast work on new entities
****************************************/
object_event_add(Flamethrower, ev_other, ev_user2, '
    if (justBlast && variable_local_exists("poof")) {
        if (instance_exists(poof)) {
            with(GNdemoPipe) {
                if(ownerPlayer.team != other.owner.team) {
                    if collision_circle(x,y,5,other.poof,false,true) motion_set(other.owner.aimDirection, speed*1.2);
                }
            }
            with(MOBAbot) {
                if(team != other.owner.team) {
                    if collision_circle(x,y,20,other.poof,false,true) {
                        motion_set(other.owner.aimDirection, 12);
                        state = 0;
                        alarm[9] = 10 / global.delta_factor;
                    }
                }
            }
        }
    }
');

/****************************************
 * Make generator look fancier
****************************************/
object_event_add(GeneratorBlue,ev_create,0,'
    explosionSprite = genGifBlueS;
    burnSprite = genAfterburnBlueS;
');

object_event_add(GeneratorRed,ev_create,0,'
    explosionSprite = genGifRedS;
    burnSprite = genAfterburnRedS;
');

globalvar genGib;
genGib = object_add();
object_event_add(global.genGib,ev_create,0,'
    image_speed = 0.55 * global.delta_factor;
    stage = 0;
    burnSprite = sprite_index;
');

object_event_add(global.genGib,ev_step,ev_step_begin,'
    if (stage == 0 && image_index >= sprite_get_number(sprite_index)-1) {
        sprite_index = burnSprite;
        image_speed = 0.25 * global.delta_factor;
        stage = 1;
    }
    
    if (stage == 1  && random(1) > 0.9 && global.run_virtual_ticks) {
        effect_create_above(ef_smokeup,x+25-random(50),y+25-random(50),0,c_gray);
    }
');

object_event_add(Generator,ev_destroy,0,'
    var animation;
    animation = instance_create(x,y,genGib);
    animation.sprite_index = explosionSprite;
    animation.burnSprite = burnSprite;
');
