globalvar GNpowerSelectController;
GNpowerSelectController = object_add();
object_set_parent(GNpowerSelectController, ClassSelectController);
object_set_depth(GNpowerSelectController, -120000);
object_event_add(GNpowerSelectController, ev_create, 0, '
    alpha=0.01;
    done = false;
    newsuper = -1;
    super = -1

    y=-120;
');

object_event_add(GNpowerSelectController, ev_step, ev_step_normal, '
    if(not done) {
        if(alpha<0.99) alpha = power(alpha,power(0.7, global.delta_factor));
        else alpha = 0.99;
        if y<120 y+=15 * global.delta_factor;
        if y>120 y=120;
    } else {
        if(alpha>0.01) alpha = power(alpha,power(1/0.7, global.delta_factor));
        y-=15 * global.delta_factor;
        if y < -120 instance_destroy();
    }

    xoffset = view_xview[0];
    yoffset = view_yview[0];
    
    if mouse_x>xoffset+160 && mouse_x <xoffset+192 && mouse_y<yoffset+50{
        newsuper=0;
        text[0]="Superpowers";
        text[1]="";
        text[2]="Gain an extra ability";
        text[3]="with far more potential";
        text[4]="than your usual attacks.";
    }
    
    else if mouse_x>xoffset+204 && mouse_x <xoffset+236 && mouse_y<yoffset+50{
        newsuper=1;
        text[0]="+25% hp";
        text[1]="";
        text[2]="Survive even the deadly";
        text[3]="backstab with your";
        text[4]="buffed body.";
    }
    
    else if mouse_x>xoffset+248 && mouse_x <xoffset+280 && mouse_y<yoffset+50{
        newsuper=2;
        text[0]="Health regeneration";
        text[1]="";
        text[2]="Almost dead with no healer?";
        text[3]="No worries, now you don"+chr(39)+"t";
        text[4]="even need one anymore.";
    }
    
    else if mouse_x>xoffset+292 && mouse_x <xoffset+324 && mouse_y<yoffset+50{
        newsuper=3;
        text[0]="+25% speed boost";
        text[1]="";
        text[2]="Keep up with a scout no";
        text[3]="problem! Until he also";
        text[4]="buys an upgrade, of course.";
    }
    
    else if mouse_x>xoffset+336 && mouse_x <xoffset+368 && mouse_y<yoffset+50{
        newsuper=4;
        text[0]="+25% damage";
        text[1]="";
        text[2]="If those buffed enemies get a";
        text[3]="little too hard to kill,";
        text[4]="you can slap them with this.";
    }
    
    else if mouse_x>xoffset+380 && mouse_x <xoffset+412 && mouse_y<yoffset+50{
        newsuper=5;
        text[0]="Spawn superbot";
        text[1]="";
        text[2]="Spawn some extra bots with";
        text[3]="more hp and a ranged attack";
        text[4]="for an extra push.";
    }
    
    else newsuper = -1;
    
    if (newsuper !=-1 && y=120) super = newsuper;
    if (mouse_check_button(mb_left) && newsuper !=-1) event_user(1);  
');  

object_event_add(GNpowerSelectController, ev_other, ev_user1, '
    if((not done) and (super != -1)) {
        var buffer;
        buffer = buffer_create();
        write_ubyte(buffer, 5);
        write_ubyte(buffer, super);
        if (global.isHost) {
            PluginPacketSendTo(global.GNPacketID, buffer, global.myself);
        } else {
            PluginPacketSend(global.GNPacketID, buffer);
        }
        buffer_destroy(buffer);
    }
    done=true;
');

object_event_add(GNpowerSelectController, ev_keypress, ord('1'), '
    super = 1;
    event_user(1);
');
object_event_add(GNpowerSelectController, ev_keypress, ord('2'), '
    super = 2;
    event_user(1);
');
object_event_add(GNpowerSelectController, ev_keypress, ord('3'), '
    super = 3;
    event_user(1);
');
object_event_add(GNpowerSelectController, ev_keypress, ord('4'), '
    super = 4;
    event_user(1);
');
object_event_add(GNpowerSelectController, ev_keypress, ord('5'), '
    super = 5;
    event_user(1);
');
object_event_add(GNpowerSelectController, ev_keypress, ord('6'), '
    super = 6;
    event_user(1);
');

object_event_add(GNpowerSelectController, ev_draw, 0, '
    var xoffset, yoffset, xsize, ysize;
    if(instance_exists(DeathCam)) exit;
    if(!(global.myself.team==TEAM_RED || global.myself.team==TEAM_BLUE)) {
        instance_destroy();
        exit;
    }
    
    xoffset = view_xview[0];
    yoffset = view_yview[0];
    xsize = view_wview[0];
    ysize = view_hview[0];
    
    if alpha < 0.8 draw_set_alpha(alpha);
    else draw_set_alpha(0.8);
    draw_rectangle_color(xoffset,yoffset,xoffset+xsize,yoffset+ysize,c_black,c_black,c_black,c_black,0);
        
    draw_sprite_ext(GNpowerSelectBG, 0, xoffset+800, yoffset+y, max(0, xsize-800), 1, 0, c_white, alpha);
    draw_sprite_ext(GNpowerSelectS, 0, xoffset+400, yoffset+y, 1, 1, 0, c_white, alpha);
    
    draw_set_color(c_white);
    draw_set_halign(fa_left);
    draw_text(xoffset+214, yoffset-120+y+80, string(max(0, floor(global.myself.stats[POINTS] - global.myself.spentPoints))));
    
    for(i=0; i<6; i+=1) {
        if (global.myself.GNupgrades[i]) draw_sprite_ext(GNpowerS,i*2+1,xoffset+160+44*i,yoffset-118+y,1,1,0,c_white,alpha);
        else if (super == i) {
            if (global.myself.stats[POINTS] - global.myself.spentPoints >= MOBA.price[i]) draw_sprite_ext(GNpowerS,i*2+1,xoffset+160+44*i,yoffset-118+y,1,1,0,c_white,alpha);
            else draw_sprite_ext(GNpowerS,i*2+1,xoffset+160+44*i,yoffset-118+y,1,1,0,c_red,alpha);
        }
        else draw_sprite_ext(GNpowerS,i*2,xoffset+160+44*i,yoffset-118+y,1,1,0,c_white,alpha);
    }
    if super != -1 && y==120 {
        //draw_sprite_ext(GNpowerS,super,xoffset+92+44*super,yoffset,1,1,0,c_white, alpha);
        draw_text(xoffset+452, yoffset+20, MOBA.price[super]);
    
        draw_text(xoffset+428,yoffset+45,text[0]);
        draw_text(xoffset+428,yoffset+60,text[1]);
        draw_text(xoffset+428,yoffset+75,text[2]);
        draw_text(xoffset+428,yoffset+90,text[3]);
        draw_text(xoffset+428,yoffset+105,text[4]);
    }
');